importPackage(java.lang);
importPackage(java.net);
importPackage(java.io);

load("iocaine2.js");

function main() {
	try {
		// T[o[ɐڑ
		var s = new Socket("192.168.1.2", 12346);
		var in2 = new BufferedReader(new InputStreamReader(s.getInputStream()));
		var out2 = new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));

		// HELLO M
		out2.write("HELLO\r\n");
		out2.flush();

		// INITIATE ҂
		print("Now read INITIATE");
		var line = in2.readLine();
		if(line == null) throw "Exception: No INITIATE";
		print(line);

		// SESSION ID擾
		var ary = line.split(" ");
		if(ary[0] != "INITIATE") throw "Exception: cmd != INITIATE";
		var sessionID = ary[1];
		print("sessionID = " + sessionID);

		// INITIATE M
		out2.write("INITIATE " + sessionID + " JavaScript 1\r\n");
		out2.flush();
		
		while(true) {
			// READY ҂
			var line = in2.readLine();
			if(line == null) throw "Exception: No READY";
			print(line);
			var ary = line.split(" ");
			if(ary[0] == "CLOSE") break;

			// round-id iteration 擾
			var roundID = ary[2];
			var iteration = ary[3];
			print("roundID = " + roundID);
			print("iteration = " + iteration);

			// READY M
			out2.write("READY " + sessionID + " " + roundID + "\r\n");
			out2.flush();

			newGame(iteration);

			// 񂯂񃁃C[v
			//for(i=0; i<iteration; i++) {
			while(true) {
				// CALL ҂
				var line = in2.readLine();
				if(line == null) throw "Exception: No CALL";
				//print(line);
				var ary = line.split(" ");
				if(ary[0] == "MATCH") break;
				
				// MOVE M
				move = calcMove();
				out2.write("MOVE " + sessionID + " " + roundID + " " + move + "\r\n");
				out2.flush();
				
				// RESULT ҂
				line = in2.readLine();
				if(line == null) throw "Exception: No RESULT";
				//print(line);
				ary = line.split(" ");
				var oppositeMove = ary[3];
				storeMove(jpn2itl(oppositeMove), 0);
				//print("oppositeMove = " + oppositeMove);
			}
		}
	} catch(e) {
		print(e);
	} finally {
		if(s != null) {
			in2.close();
			out2.close();
			s.close();
		}
	}
}

function calcMove() {
	// return Math.floor(Math.random() * 3) + 1;
	return itl2jpn(nextMove());
}

function itl2jpn(move) {
	return [1,3,2][move];
}

function jpn2itl(move) {
	return [0,0,2,1][move];
}

while(true) {
	main();
	Thread.sleep(1000); // T[o[Ă邩`FbN̂͂PbɂP܂
}
